CreateFrame("Frame", "Quest", QuestBar);
WatchFrame:SetClampedToScreen(false) 
WatchFrame:SetMovable(1) 
WatchFrame:SetUserPlaced(true)	
WatchFrame:ClearAllPoints() 
WatchFrame:SetPoint("CENTER", Quest, "CENTER", 0, 0)
WatchFrame:SetParent(Quest);

WatchFrameCollapseExpandButton:ClearAllPoints() 
WatchFrameCollapseExpandButton:SetParent(WatchFrameHeader)
WatchFrameCollapseExpandButton:SetPoint("TOPLEFT", WatchFrameHeader, "TOPLEFT", WatchFrame:GetWidth()+50, 0)
WatchFrame:SetHeight(550);
WATCHFRAME_COLLAPSEDWIDTH = 204;
WATCHFRAME_EXPANDEDWIDTH = 204;

	
local menuButtons
do
	local loadButtons = function(...)
		menuButtons = {}
		
		for i = 1, select('#', ...) do
			local b = select(i, ...)
			local name = b:GetName()
				table.insert(menuButtons, b)
		end
	end
	loadButtons(_G['Quest']:GetChildren())
end
--[[ Minimap ]]--
local DMAP = Dominos:NewModule('Quest Frame')
local MAP

function DMAP:Load()
	self.frame = MAP:New()
	self.frame:SetFrameStrata('LOW')
end
function DMAP:Unload()
	self.frame:Free()
end



MAP = Dominos:CreateClass('Frame', Dominos.Frame)


function MAP:New()
	local f = self.super.New(self, 'Quests')
	if not f.value then
		f:SetFrameStrata('BACKGROUND')
		f:LoadButtons()
	end

	f:Layout()


	return f
end


function MAP:GetDefaults()
	return {
		scale = 1,
		point = 'CENTER',
		anchor = 'Buttons2BR',
		y = 0,
		x = 0,
	}
end
function MAP:NumButtons()
	return #menuButtons
end

function MAP:AddButton(i)
	local b = menuButtons[i]
	if b then
		b:SetParent(self.header)
		b:Show()

		self.buttons[i] = b
	end
end

function MAP:RemoveButton(i)
	local b = self.buttons[i]
	if b then
		b:SetParent(nil)
		b:Hide()

		self.buttons[i] = nil
	end
end










local function AddLayoutPanel(menu)
	local p = menu:NewPanel(LibStub('AceLocale-3.0'):GetLocale('Dominos-Config').Layout)
		p:NewOpacitySlider()
		p:NewFadeSlider()
		p:NewScaleSlider()
		p:NewPaddingSlider()	
		p:NewColumnsSlider()
end
local function AddShowState(self)
		local p = self:NewPanel("Show States")
		p.height = 56

		local editBox = CreateFrame('EditBox', p:GetName() .. 'StateText', p,  'InputBoxTemplate')
		editBox:SetWidth(148) editBox:SetHeight(20)
		editBox:SetPoint('TOPLEFT', 12, -10)
		editBox:SetAutoFocus(false)
		editBox:SetScript('OnShow', function(self)
			self:SetText(self:GetParent().owner:GetShowStates() or '')
		end)
		editBox:SetScript('OnEnterPressed', function(self)
			local text = self:GetText()
			self:GetParent().owner:SetShowStates(text ~= '' and text or nil)
		end)
		editBox:SetScript('OnEditFocusLost', function(self) self:HighlightText(0, 0) end)
		editBox:SetScript('OnEditFocusGained', function(self) self:HighlightText() end)

		local set = CreateFrame('Button', p:GetName() .. 'Set', p, 'UIPanelButtonTemplate')
		set:SetWidth(30) set:SetHeight(20)
		set:SetText("Set")
		set:SetScript('OnClick', function(self)
			local text = editBox:GetText()
			self:GetParent().owner:SetShowStates(text ~= '' and text or nil)
			editBox:SetText(self:GetParent().owner:GetShowStates() or '')
		end)
		set:SetPoint('BOTTOMRIGHT', -8, 2)

		return p
	end
function MAP:CreateMenu()
	local menu = Dominos:NewMenu(self.id)
	AddLayoutPanel(menu)
	AddShowState(menu)
	self.menu = menu
end


